From cc5a75ee050e796a255ba0f3dd786a3b9ffab62e Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: May 02 2019 14:16:31 +0000
Subject: [PATCH 4/7] Make election's logging configuration configurable


Signed-off-by: Pierre-Yves Chibon <pingou@pingoured.fr>

---

diff --git a/fedora_elections/__init__.py b/fedora_elections/__init__.py
index 030f76f..c782d8f 100644
--- a/fedora_elections/__init__.py
+++ b/fedora_elections/__init__.py
@@ -48,7 +48,6 @@ from fedora.client.fas2 import AccountSystem  # noqa
 from flask_oidc import OpenIDConnect  # noqa
 
 import fedora_elections.fedmsgshim  # noqa
-import fedora_elections.mail_logging  # noqa
 import fedora_elections.proxy  # noqa
 
 APP = flask.Flask(__name__)
@@ -59,18 +58,8 @@ if 'FEDORA_ELECTIONS_CONFIG' in os.environ:  # pragma: no cover
 # set up FAS
 OIDC = OpenIDConnect(APP, credentials_store=flask.session)
 
-# Set up the logging
-if not APP.debug:
-    APP.logger.addHandler(fedora_elections.mail_logging.get_mail_handler(
-        smtp_server=APP.config.get('SMTP_SERVER', '127.0.0.1'),
-        mail_admin=APP.config.get('MAIL_ADMIN', 'admin@fedoraproject.org')
-    ))
-
-# Log to stderr as well
-STDERR_LOG = logging.StreamHandler(sys.stderr)
-STDERR_LOG.setLevel(logging.INFO)
-APP.logger.addHandler(STDERR_LOG)
-
+logging.basicConfig()
+logging.config.dictConfig(APP.config.get("LOGGING") or {"version": 1})
 LOG = APP.logger
 
 APP.wsgi_app = fedora_elections.proxy.ReverseProxied(APP.wsgi_app)
diff --git a/fedora_elections/default_config.py b/fedora_elections/default_config.py
index 938cb53..42c6d44 100644
--- a/fedora_elections/default_config.py
+++ b/fedora_elections/default_config.py
@@ -29,3 +29,71 @@ OIDC_CLIENT_SECRETS = os.path.join(os.path.dirname(
     os.path.abspath(__file__)), '..', 'client_secrets.json')
 OIDC_SCOPES = ['openid', 'email', 'profile', 'fedora']
 OIDC_OPENID_REALM = 'http://localhost:5005/oidc_callback'
+
+LOGGING = {
+    "version": 1,
+    "disable_existing_loggers": False,
+    "formatters": {
+        "standard": {
+            "format": "%(asctime)s [%(levelname)s] %(name)s: %(message)s"
+        },
+        "email_format": {"format": MSG_FORMAT},
+    },
+    "filters": {"myfilter": {"()": ContextInjector}},
+    "handlers": {
+        "console": {
+            "level": "DEBUG",
+            "formatter": "standard",
+            "class": "logging.StreamHandler",
+            "stream": "ext://sys.stdout",
+        },
+        "email": {
+            "level": "ERROR",
+            "formatter": "email_format",
+            "class": "logging.handlers.SMTPHandler",
+            "mailhost": "localhost",
+            "fromaddr": "elections@localhost",
+            "toaddrs": "elections@localhost",
+            "subject": "ERROR on elections",
+            "filters": ["myfilter"],
+        },
+    },
+    # The root logger configuration; this is a catch-all configuration
+    # that applies to all log messages not handled by a different logger
+    "root": {
+        "level": "DEBUG",
+        "handlers": ["console"]
+    },
+    "loggers": {
+        "fedora_elections": {
+            "handlers": ["console"],
+            "level": "DEBUG",
+            "propagate": True,
+        },
+        "flask": {
+            "handlers": ["console"],
+            "level": "INFO",
+            "propagate": True,
+        },
+        "flask_oidc": {
+            "handlers": ["console"],
+            "level": "INFO",
+            "propagate": False,
+        },
+        "sqlalchemy": {
+            "handlers": ["console"],
+            "level": "WARN",
+            "propagate": False,
+        },
+        "fedora_messaging": {
+            "handlers": ["console"],
+            "level": "INFO",
+            "propagate": True,
+        },
+        "pika": {
+            "handlers": ["console"],
+            "level": "WARN",
+            "propagate": True,
+        },
+    },
+}

